<?php
// $Id: cufon.admin.inc,v 1.1 2009/07/13 21:41:46 eads Exp $
/**
 * @file
 * Provides the administration page for Cufon.
 */
DEFINE('CUFON_ADDITIONAL_FORM_ELEMENTS', 2);

/**
 * Administration settings page
 */
function cufon_admin() {
  $selectors = variable_get('cufon_selectors', array());

  $fonts = array('------');
  foreach (_cufon_get_fonts() as $font) {
    $fonts[$font] = $font;
  }

  $form = array(
    'cufon_selectors' =>  array(
      '#type' => 'fieldset',
      '#tree' => TRUE,
    ),
  );
  $i = 0;
  while ($i < (count($selectors) + CUFON_ADDITIONAL_FORM_ELEMENTS)) { 
    $form['cufon_selectors'][$i] = array(
      '#prefix' => '<div class="cufon-settings-row">',
      '#suffix' => '</div>',
      'selector' => array(
        '#type' => 'textarea',
        '#title' => t('Selector'),
        '#cols' => 30,
        '#rows' => 2,
      ),
      'options' => array(
        '#tree' => TRUE,
        'fontFamily' => array(
          '#type' => 'select',
          '#title' => t('Font family'),
          '#options' => $fonts,
        ),
        'hover' => array(
          '#type' => 'checkbox',
          '#title' => t('Enable hover state support'),
          '#default_value' => 0,
          '#description' => t('Adds support for <code>:hover</code> states.  For performance reasons, this is disabled by default.'),
        ),
      ),
    );
    // Slightly hoary use of position
    if (($s = $selectors[$i])) {
      $form['cufon_selectors'][$i]['selector']['#default_value'] = check_plain($s['selector']);
      $form['cufon_selectors'][$i]['options']['fontFamily']['#default_value'] = $s['options']['fontFamily'];
      $form['cufon_selectors'][$i]['options']['hover']['#default_value'] = $s['options']['hover'];
    }
    $i++;
  }
  $form['#submit'][] = 'cufon_admin_submit';
  return system_settings_form($form);
}

/**
 * Submit callback for cufon administrative settings
 *
 * Filters out empty form elements.
 */
function cufon_admin_submit($form, &$form_state) {
  foreach ($form_state['values']['cufon_selectors'] as $row => $options) {
    if (empty($options['selector']) && empty($options['options']['fontFamily'])) {
      unset($form_state['values']['cufon_selectors'][$row]);
    }
  }
}
